<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>OAP</title>
</head>
<body style="background-color: #FFFFFF; margin: 0px; font: small Verdana, sans-serif; font-size: 12px; color: #1A1A1A;"><div style="width: 98%; width:700px; align: center; margin-left: auto; margin-right: auto;"><table style="width: 100%;" cellpadding="3" cellspacing="0"><tr><td valign="top">
<h1>OAP:
                  OpenVAS Administrator Protocol</h1>
<p>Version: 1.1</p>
<p>The "administrator" protocol of the Open Vulnerability Assessment System.</p>
<h2 id="contents">Contents</h2>
<ol>
<li><a href="#type_summary">Summary of Data Types</a></li>
<li><a href="#element_summary">Summary of Elements</a></li>
<li><a href="#command_summary">Summary of Commands</a></li>
<li><a href="#rnc_preamble">RNC Preamble</a></li>
<li><a href="#type_details">Data Type Details</a></li>
<li><a href="#element_details">Element Details</a></li>
<li><a href="#command_details">Command Details</a></li>
</ol>
<h2 id="type_summary">1 Summary of Data Types</h2>
<table id="index">
<tr id="index">
<td id="index"><a href="#type_base64">base64</a></td>
<td id="index"><div style="margin-left: 15px;">Base64 encoded data.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_boolean">boolean</a></td>
<td id="index"><div style="margin-left: 15px;">A true or false value.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_boolean_atoi">boolean_atoi</a></td>
<td id="index"><div style="margin-left: 15px;">A true or false value, after conversion to an integer.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_ctime">ctime</a></td>
<td id="index"><div style="margin-left: 15px;">A date and time, in the C `ctime' format.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_type_name">type_name</a></td>
<td id="index"><div style="margin-left: 15px;">A name of a data type.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_integer">integer</a></td>
<td id="index"><div style="margin-left: 15px;">An integer.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_levels">levels</a></td>
<td id="index"><div style="margin-left: 15px;">A string that may include the characters h, m, l, g and d.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_name">name</a></td>
<td id="index"><div style="margin-left: 15px;">A name.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_oid">oid</a></td>
<td id="index"><div style="margin-left: 15px;">An Object Identifier (OID).</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_sort_order">sort_order</a></td>
<td id="index"><div style="margin-left: 15px;">A string describing an order for sorting.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_status">status</a></td>
<td id="index"><div style="margin-left: 15px;">The success or failure status of a command.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_task_status">task_status</a></td>
<td id="index"><div style="margin-left: 15px;">A task run status.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_task_trend">task_trend</a></td>
<td id="index"><div style="margin-left: 15px;">The trend of results for a task.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_threat">threat</a></td>
<td id="index"><div style="margin-left: 15px;">A threat level.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_time_unit">time_unit</a></td>
<td id="index"><div style="margin-left: 15px;">A unit of time.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_uuid">uuid</a></td>
<td id="index"><div style="margin-left: 15px;">A Universally Unique Identifier (UUID).</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#type_uuid_or_empty">uuid_or_empty</a></td>
<td id="index"><div style="margin-left: 15px;">A Universally Unique Identifier (UUID), or the empty string.</div></td>
</tr>
</table>
<h2 id="element_summary">2 Summary of Elements</h2>
<table id="index">
<tr id="index">
<td id="index"><a href="#element_c">c</a></td>
<td id="index"><div style="margin-left: 15px;">A reference to a command.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#element_e">e</a></td>
<td id="index"><div style="margin-left: 15px;">A reference to an element.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#element_r">r</a></td>
<td id="index"><div style="margin-left: 15px;">A reference to a response.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#element_o">o</a></td>
<td id="index"><div style="margin-left: 15px;">An optional pattern item.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#element_g">g</a></td>
<td id="index"><div style="margin-left: 15px;">A group of pattern items.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#element_any">any</a></td>
<td id="index"><div style="margin-left: 15px;">Pattern item indicating "any number of".</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#element_pattern">pattern</a></td>
<td id="index"><div style="margin-left: 15px;">The pattern element of a command or command descendant.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#element_command_definition">command_definition</a></td>
<td id="index"><div style="margin-left: 15px;">Definition of a command in OAP describing HELP command.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#element_sources">sources</a></td>
<td id="index"><div style="margin-left: 15px;">List of authentication sources associated to a user.</div></td>
</tr>
</table>
<h2 id="command_summary">3 Summary of Commands</h2>
<table id="index">
<tr id="index">
<td id="index"><a href="#command_authenticate">authenticate</a></td>
<td id="index"><div style="margin-left: 15px;">Authenticate with the Administrator.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_commands">commands</a></td>
<td id="index"><div style="margin-left: 15px;">Run a list of commands.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_create_user">create_user</a></td>
<td id="index"><div style="margin-left: 15px;">Create a user.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_delete_user">delete_user</a></td>
<td id="index"><div style="margin-left: 15px;">Delete a user.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_describe_auth">describe_auth</a></td>
<td id="index"><div style="margin-left: 15px;">Describe a auth.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_describe_feed">describe_feed</a></td>
<td id="index"><div style="margin-left: 15px;">Describe the NVT feed.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_describe_scap">describe_scap</a></td>
<td id="index"><div style="margin-left: 15px;">Describe the SCAP feed.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_describe_cert">describe_cert</a></td>
<td id="index"><div style="margin-left: 15px;">Describe the CERT feed.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_get_settings">get_settings</a></td>
<td id="index"><div style="margin-left: 15px;">Get all settings.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_get_users">get_users</a></td>
<td id="index"><div style="margin-left: 15px;">Get all users.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_get_version">get_version</a></td>
<td id="index"><div style="margin-left: 15px;">Get the OpenVAS Administrator Protocol version.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_help">help</a></td>
<td id="index"><div style="margin-left: 15px;">Get the help text.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_modify_auth">modify_auth</a></td>
<td id="index"><div style="margin-left: 15px;">Modify the authentication methods.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_modify_user">modify_user</a></td>
<td id="index"><div style="margin-left: 15px;">Modify a user.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_sync_feed">sync_feed</a></td>
<td id="index"><div style="margin-left: 15px;">Synchronize with an NVT feed.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_sync_scap">sync_scap</a></td>
<td id="index"><div style="margin-left: 15px;">Synchronize with a SCAP feed.</div></td>
</tr>
<tr id="index">
<td id="index"><a href="#command_sync_cert">sync_cert</a></td>
<td id="index"><div style="margin-left: 15px;">Synchronize with a CERT feed.</div></td>
</tr>
</table>
<h2 id="rnc_preamble">4 RNC Preamble</h2>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>### Preamble

start = command | response

command
  = authenticate
    | commands
    | create_user
    | delete_user
    | describe_auth
    | describe_feed
    | describe_scap
    | describe_cert
    | get_settings
    | get_users
    | get_version
    | help
    | modify_auth
    | modify_user
    | sync_feed
    | sync_scap
    | sync_cert

response
  = authenticate_response
    | commands_response
    | create_user_response
    | delete_user_response
    | describe_auth_response
    | describe_feed_response
    | describe_scap_response
    | describe_cert_response
    | get_settings_response
    | get_users_response
    | get_version_response
    | help_response
    | modify_auth_response
    | modify_user_response
    | sync_feed_response
    | sync_scap_response
    | sync_cert_response
</pre></div>
<h2 id="type_details">5 Data Type Details</h2>
<div>
<div><h3 id="type_base64">5.1
        Data Type <tt>base64</tt>
</h3></div>
<p>In short: Base64 encoded data.</p>
<h4>5.1.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>base64 = xsd:base64Binary
</pre></div>
</div>
<div>
<div><h3 id="type_boolean">5.2
        Data Type <tt>boolean</tt>
</h3></div>
<p>In short: A true or false value.</p>
<p>
      Zero is false, anything else is true.  As a result, the empty string is
      considered true.
    </p>
<h4>5.2.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>boolean = text
</pre></div>
</div>
<div>
<div><h3 id="type_boolean_atoi">5.3
        Data Type <tt>boolean_atoi</tt>
</h3></div>
<p>In short: A true or false value, after conversion to an integer.</p>
<p>
      Zero is false, anything else is true.  The value is first converted to
      an integer, as by the C `atoi' routine.  This means that an empty string
      is considered false.
    </p>
<h4>5.3.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>boolean_atoi = text
</pre></div>
</div>
<div>
<div><h3 id="type_ctime">5.4
        Data Type <tt>ctime</tt>
</h3></div>
<p>In short: A date and time, in the C `ctime' format.</p>
<p>
      An example string in this format is "Wed Jun 30 21:49:08 1993\n".
    </p>
<h4>5.4.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>ctime = text
</pre></div>
</div>
<div>
<div><h3 id="type_type_name">5.5
        Data Type <tt>type_name</tt>
</h3></div>
<p>In short: A name of a data type.</p>
<h4>5.5.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>type_name = xsd:string - xsd:whitespace
</pre></div>
</div>
<div>
<div><h3 id="type_integer">5.6
        Data Type <tt>integer</tt>
</h3></div>
<p>In short: An integer.</p>
<h4>5.6.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>integer = xsd:integer
</pre></div>
</div>
<div>
<div><h3 id="type_levels">5.7
        Data Type <tt>levels</tt>
</h3></div>
<p>In short: A string that may include the characters h, m, l, g and d.</p>
<h4>5.7.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>levels = xsd:token { pattern = "h?m?l?g?d?" }
</pre></div>
</div>
<div>
<div><h3 id="type_name">5.8
        Data Type <tt>name</tt>
</h3></div>
<p>In short: A name.</p>
<h4>5.8.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>name = xsd:string
</pre></div>
</div>
<div>
<div><h3 id="type_oid">5.9
        Data Type <tt>oid</tt>
</h3></div>
<p>In short: An Object Identifier (OID).</p>
<h4>5.9.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>oid = xsd:token { pattern = "[0-9\.]{1,80}" }
</pre></div>
</div>
<div>
<div><h3 id="type_sort_order">5.10
        Data Type <tt>sort_order</tt>
</h3></div>
<p>In short: A string describing an order for sorting.</p>
<p>
      The string "descending" denotes descending order, anything else means
      ascending.
    </p>
<h4>5.10.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>sort_order = text
</pre></div>
</div>
<div>
<div><h3 id="type_status">5.11
        Data Type <tt>status</tt>
</h3></div>
<p>In short: The success or failure status of a command.</p>
<h4>5.11.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>status = xsd:token { pattern = "200|201|202|400|401|403|404|409|500|503" }
</pre></div>
</div>
<div>
<div><h3 id="type_task_status">5.12
        Data Type <tt>task_status</tt>
</h3></div>
<p>In short: A task run status.</p>
<h4>5.12.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>task_status = xsd:token { pattern = "Delete Requested|Done|New|Pause Requested|Paused|Requ↵
ested|Resume Requested|Running|Stop Requested|Stopped|Internal Error" }
</pre></div>
</div>
<div>
<div><h3 id="type_task_trend">5.13
        Data Type <tt>task_trend</tt>
</h3></div>
<p>In short: The trend of results for a task.</p>
<h4>5.13.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>task_trend = xsd:token { pattern = "up|down|more|less|same" }
</pre></div>
</div>
<div>
<div><h3 id="type_threat">5.14
        Data Type <tt>threat</tt>
</h3></div>
<p>In short: A threat level.</p>
<h4>5.14.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>threat = xsd:token { pattern = "High|Medium|Low|Log|Debug" }
</pre></div>
</div>
<div>
<div><h3 id="type_time_unit">5.15
        Data Type <tt>time_unit</tt>
</h3></div>
<p>In short: A unit of time.</p>
<h4>5.15.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>time_unit = xsd:token { pattern = "second|minute|hour|day|week|month|year|decade" }
</pre></div>
</div>
<div>
<div><h3 id="type_uuid">5.16
        Data Type <tt>uuid</tt>
</h3></div>
<p>In short: A Universally Unique Identifier (UUID).</p>
<h4>5.16.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>uuid = xsd:token { pattern = "[0-9abcdefABCDEF\-]{1,40}" }
</pre></div>
</div>
<div>
<div><h3 id="type_uuid_or_empty">5.17
        Data Type <tt>uuid_or_empty</tt>
</h3></div>
<p>In short: A Universally Unique Identifier (UUID), or the empty string.</p>
<h4>5.17.1 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><pre>uuid_or_empty = xsd:token { pattern = "[0-9abcdefABCDEF\-]{0,40}" }
</pre></div>
</div>
<h2 id="element_details">6 Element Details</h2>
<div>
<div><h3 id="element_c">6.1
        Element <tt>c</tt>
</h3></div>
<p>In short: A reference to a command.</p>
<h4>6.1.1 Structure</h4>
<ul style="list-style: none"><li><ul style="list-style: none"></ul></li></ul>
<h4>6.1.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><div style="margin-left: 5%"><pre>c
 = element c
     {
       text
     }
</pre></div></div>
</div>
<div>
<div><h3 id="element_e">6.2
        Element <tt>e</tt>
</h3></div>
<p>In short: A reference to an element.</p>
<h4>6.2.1 Structure</h4>
<ul style="list-style: none"><li><ul style="list-style: none"></ul></li></ul>
<h4>6.2.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><div style="margin-left: 5%"><pre>e
 = element e
     {
       text
     }
</pre></div></div>
</div>
<div>
<div><h3 id="element_r">6.3
        Element <tt>r</tt>
</h3></div>
<p>In short: A reference to a response.</p>
<h4>6.3.1 Structure</h4>
<ul style="list-style: none"><li><ul style="list-style: none"></ul></li></ul>
<h4>6.3.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><div style="margin-left: 5%"><pre>r
 = element r
     {
       text
     }
</pre></div></div>
</div>
<div>
<div><h3 id="element_o">6.4
        Element <tt>o</tt>
</h3></div>
<p>In short: An optional pattern item.</p>
<h4>6.4.1 Structure</h4>
<ul style="list-style: none"><li><ul style="list-style: none"><li>
<i>One of</i><b></b><ul style="list-style: none">
<li>
              &lt;<a href="#element_c"><b>c</b></a>&gt;
              <div style="margin-left: 15px; display: inline;">A reference to a command.</div>
</li>
<li>
              &lt;<a href="#element_e"><b>e</b></a>&gt;
              <div style="margin-left: 15px; display: inline;">A reference to an element.</div>
</li>
<li>
              &lt;<a href="#element_r"><b>r</b></a>&gt;
              <div style="margin-left: 15px; display: inline;">A reference to a response.</div>
</li>
<li>
              &lt;<a href="#element_g"><b>g</b></a>&gt;
              <div style="margin-left: 15px; display: inline;">A group of pattern items.</div>
</li>
</ul>
</li></ul></li></ul>
<h4>6.4.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><div style="margin-left: 5%"><pre>o
 = element o
     {
       ( c
           | e
           | r
           | g )
     }
</pre></div></div>
</div>
<div>
<div><h3 id="element_g">6.5
        Element <tt>g</tt>
</h3></div>
<p>In short: A group of pattern items.</p>
<h4>6.5.1 Structure</h4>
<ul style="list-style: none"><li><ul style="list-style: none">
<li>
              &lt;<a href="#element_c"><b>c</b></a>&gt;
              *<div style="margin-left: 15px; display: inline;">A reference to a command.</div>
</li>
<li>
              &lt;<a href="#element_e"><b>e</b></a>&gt;
              *<div style="margin-left: 15px; display: inline;">A reference to an element.</div>
</li>
<li>
              &lt;<a href="#element_r"><b>r</b></a>&gt;
              *<div style="margin-left: 15px; display: inline;">A reference to a response.</div>
</li>
<li>
              &lt;<a href="#element_o"><b>o</b></a>&gt;
              *<div style="margin-left: 15px; display: inline;">An optional pattern item.</div>
</li>
<li>
              &lt;<a href="#element_any"><b>any</b></a>&gt;
              *<div style="margin-left: 15px; display: inline;">Pattern item indicating "any number of".</div>
</li>
</ul></li></ul>
<h4>6.5.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><div style="margin-left: 5%"><pre>g
 = element g
     {
       c*
       &amp; e*
       &amp; r*
       &amp; o*
       &amp; any*
     }
</pre></div></div>
</div>
<div>
<div><h3 id="element_any">6.6
        Element <tt>any</tt>
</h3></div>
<p>In short: Pattern item indicating "any number of".</p>
<h4>6.6.1 Structure</h4>
<ul style="list-style: none"><li><ul style="list-style: none"><li>
<i>One of</i><b></b><ul style="list-style: none">
<li>
              &lt;<a href="#element_c"><b>c</b></a>&gt;
              <div style="margin-left: 15px; display: inline;">A reference to a command.</div>
</li>
<li>
              &lt;<a href="#element_e"><b>e</b></a>&gt;
              <div style="margin-left: 15px; display: inline;">A reference to an element.</div>
</li>
<li>
              &lt;<a href="#element_r"><b>r</b></a>&gt;
              <div style="margin-left: 15px; display: inline;">A reference to a response.</div>
</li>
<li>
              &lt;<a href="#element_g"><b>g</b></a>&gt;
              <div style="margin-left: 15px; display: inline;">A group of pattern items.</div>
</li>
</ul>
</li></ul></li></ul>
<h4>6.6.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><div style="margin-left: 5%"><pre>any
 = element any
     {
       ( c
           | e
           | r
           | g )
     }
</pre></div></div>
</div>
<div>
<div><h3 id="element_pattern">6.7
        Element <tt>pattern</tt>
</h3></div>
<p>In short: The pattern element of a command or command descendant.</p>
<p>
      It's actually either a 't' element, or the word "text", or "".
    </p>
<h4>6.7.1 Structure</h4>
<ul style="list-style: none"><li><ul style="list-style: none">
<li>
              &lt;<b>attrib</b>&gt;
              *<div style="margin-left: 15px; display: inline;">An attribute.</div>
<ul style="list-style: none">
<li>
              &lt;<b>name</b>&gt;
              <ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>type</b>&gt;
              <ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>required</b>&gt;
              <ul style="list-style: none"></ul>
</li>
</ul>
</li>
<li>
              &lt;<a href="#element_c"><b>c</b></a>&gt;
              *<div style="margin-left: 15px; display: inline;">A reference to a command.</div>
</li>
<li>
              &lt;<a href="#element_e"><b>e</b></a>&gt;
              *<div style="margin-left: 15px; display: inline;">A reference to an element.</div>
</li>
<li>
              &lt;<a href="#element_r"><b>r</b></a>&gt;
              *<div style="margin-left: 15px; display: inline;">A reference to a response.</div>
</li>
<li>
              &lt;<a href="#element_o"><b>o</b></a>&gt;
              *<div style="margin-left: 15px; display: inline;">An optional pattern item.</div>
</li>
<li>
              &lt;<a href="#element_g"><b>g</b></a>&gt;
              *<div style="margin-left: 15px; display: inline;">A group of pattern items.</div>
</li>
<li>
              &lt;<a href="#element_any"><b>any</b></a>&gt;
              *<div style="margin-left: 15px; display: inline;">Pattern item indicating "any number of".</div>
</li>
<li>
              &lt;<b>t</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">The type of the text of the element.</div>
<ul style="list-style: none"></ul>
</li>
</ul></li></ul>
<h4>6.7.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><div style="margin-left: 5%"><pre>pattern
 = element pattern
     {
       text
       &amp; pattern_attrib*
       &amp; c*
       &amp; e*
       &amp; r*
       &amp; o*
       &amp; g*
       &amp; any*
       &amp; pattern_t?
     }

pattern_attrib
 = element attrib
     {
       pattern_attrib_name
       &amp; pattern_attrib_type
       &amp; pattern_attrib_required
     }

pattern_attrib_name
 = element name
     {
       type_name
     }

pattern_attrib_type
 = element type
     {
       type_name
     }

pattern_attrib_required
 = element required
     {
       boolean
     }

pattern_t
 = element t
     {
       type_name
     }
</pre></div></div>
</div>
<div>
<div><h3 id="element_command_definition">6.8
        Element <tt>command_definition</tt>
</h3></div>
<p>In short: Definition of a command in OAP describing HELP command.</p>
<h4>6.8.1 Structure</h4>
<ul style="list-style: none"><li><ul style="list-style: none">
<li>
              &lt;<b>name</b>&gt;
              <div style="margin-left: 15px; display: inline;">The name of the command.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>summary</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">A summary of the command.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>description</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">A description of the command.</div>
<ul style="list-style: none"><li>
              &lt;<b>p</b>&gt;
              *<div style="margin-left: 15px; display: inline;">A paragraph.</div>
<ul style="list-style: none"></ul>
</li></ul>
</li>
<li>
<i>One of</i><b></b><ul style="list-style: none">
<li>
<i>The group</i><b></b><ul style="list-style: none">
<li>
              &lt;<b>pattern</b>&gt;
              <div style="margin-left: 15px; display: inline;">(<a href="#element_pattern">pattern</a>)</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>response</b>&gt;
              <div style="margin-left: 15px; display: inline;">(<a href="#element_pattern">pattern</a>)</div>
<ul style="list-style: none"></ul>
</li>
</ul>
</li>
<li>
<i>The group</i><b></b><ul style="list-style: none">
<li>
              &lt;<b>type</b>&gt;
              <div style="margin-left: 15px; display: inline;">The type of the element.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>ele</b>&gt;
              *<div style="margin-left: 15px; display: inline;">(<a href="#element_command_definition">command_definition</a>)</div>
<div style="margin-left: 15px; display: inline;">An element.</div>
<ul style="list-style: none"></ul>
</li>
</ul>
</li>
</ul>
</li>
<li>
              &lt;<b>example</b>&gt;
              *<ul style="list-style: none">
<li>
              &lt;<b>summary</b>&gt;
              ?<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>description</b>&gt;
              ?<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>request</b>&gt;
              <div style="margin-left: 15px; display: inline;">Example request.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>response</b>&gt;
              <div style="margin-left: 15px; display: inline;">Response to example request.</div>
<ul style="list-style: none"></ul>
</li>
</ul>
</li>
</ul></li></ul>
<h4>6.8.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><div style="margin-left: 5%"><pre>command_definition
 = element command_definition
     {
       command_definition_name
       &amp; command_definition_summary?
       &amp; command_definition_description?
       &amp; ( ( command_definition_pattern
           &amp; command_definition_response )
           | ( command_definition_type
           &amp; command_definition_ele* ) )
       &amp; command_definition_example*
     }

command_definition_name
 = element name
     {
       type_name
     }

command_definition_summary
 = element summary
     {
       text
     }

command_definition_description
 = element description
     {
       text
       &amp; command_definition_description_p*
     }

command_definition_description_p
 = element p
     {
       text
     }

command_definition_pattern
 = element pattern    # type pattern
     {
       text
       &amp; pattern_attrib*
       &amp; c*
       &amp; e*
       &amp; r*
       &amp; o*
       &amp; g*
       &amp; any*
       &amp; pattern_t?
     }

command_definition_response
 = element response    # type pattern
     {
       text
       &amp; pattern_attrib*
       &amp; c*
       &amp; e*
       &amp; r*
       &amp; o*
       &amp; g*
       &amp; any*
       &amp; pattern_t?
     }

command_definition_example
 = element example
     {
       command_definition_example_summary?
       &amp; command_definition_example_description?
       &amp; command_definition_example_request
       &amp; command_definition_example_response
     }

command_definition_example_summary
 = element summary
     {
       text
     }

command_definition_example_description
 = element description
     {
       text
     }

command_definition_example_request
 = element request
     {
       text
     }

command_definition_example_response
 = element response
     {
       text
     }

command_definition_type
 = element type
     {
       text
     }

command_definition_ele
 = element ele    # type command_definition
     {
       command_definition_name
       &amp; command_definition_summary?
       &amp; command_definition_description?
       &amp; ( ( command_definition_pattern
           &amp; command_definition_response )
           | ( command_definition_type
           &amp; command_definition_ele* ) )
       &amp; command_definition_example*
     }
</pre></div></div>
</div>
<div>
<div><h3 id="element_sources">6.9
        Element <tt>sources</tt>
</h3></div>
<p>In short: List of authentication sources associated to a user.</p>
<h4>6.9.1 Structure</h4>
<ul style="list-style: none"><li><ul style="list-style: none"><li>
              &lt;<b>source</b>&gt;
              *<div style="margin-left: 15px; display: inline;">The name of the authentication source.</div>
<ul style="list-style: none"></ul>
</li></ul></li></ul>
<h4>6.9.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;"><div style="margin-left: 5%"><pre>sources
 = element sources
     {
       sources_source*
     }

sources_source
 = element source
     {
       text
     }
</pre></div></div>
</div>
<h2 id="command_details">7 Command Details</h2>
<div>
<div><h3 id="command_authenticate">7.1
        Command <tt>authenticate</tt>
</h3></div>
<p>In short: Authenticate with the Administrator.</p>
<p>
        The client uses the authenticate command to authenticate with the
        Administrator.
      </p>
<p>
        The client normally executes this command at the beginning of each
        connection.  The only commands permitted before authentication are
        get_version and commands.
      </p>
<h4>7.1.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><li>
              &lt;<b>credentials</b>&gt;
              <ul style="list-style: none">
<li>
              &lt;<b>username</b>&gt;
              <div style="margin-left: 15px; display: inline;">The login name of the user.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>password</b>&gt;
              <div style="margin-left: 15px; display: inline;">The user's password.</div>
<ul style="list-style: none"></ul>
</li>
</ul>
</li></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
</ul>
</li>
</ul>
<h4>7.1.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>authenticate
 = element authenticate
     {
       authenticate_credentials
     }

authenticate_credentials
 = element credentials
     {
       authenticate_credentials_username
       &amp; authenticate_credentials_password
     }

authenticate_credentials_username
 = element username
     {
       text
     }

authenticate_credentials_password
 = element password
     {
       text
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>authenticate_response
 = element authenticate_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
     }
</pre></div>
</div>
<h4>7.1.3 Example: Authenticate with a good password</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;authenticate&gt;
   &lt;credentials&gt;
     &lt;username&gt;sally&lt;/username&gt;
     &lt;password&gt;secret&lt;/password&gt;
   &lt;/credentials&gt;
 &lt;/authenticate&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;authenticate_response status="200"
                        status_text="OK"/&gt;
</pre></div>
</div>
<h4>7.1.3 Example: Authenticate with a bad password</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;authenticate&gt;
   &lt;credentials&gt;
     &lt;username&gt;sally&lt;/username&gt;
     &lt;password&gt;secrte&lt;/password&gt;
   &lt;/credentials&gt;
 &lt;/authenticate&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;authenticate_response status="400"
                        status_text="Authentication failed"/&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_commands">7.2
        Command <tt>commands</tt>
</h3></div>
<p>In short: Run a list of commands.</p>
<p>
      The client uses the commands command to run a list of commands.  The
      elements are executed as OAP commands in the given sequence.  The reply
      contains the result of each command, in the same order as the given
      commands.
    </p>
<h4>7.2.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><li>
<i>One of</i><b>*</b><ul style="list-style: none">
<li>
          &lt;<b>authenticate&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_authenticate">authenticate</a> command.
          </div>
</li>
<li>
          &lt;<b>commands&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_commands">commands</a> command.
          </div>
</li>
<li>
          &lt;<b>create_user&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_create_user">create_user</a> command.
          </div>
</li>
<li>
          &lt;<b>delete_user&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_delete_user">delete_user</a> command.
          </div>
</li>
<li>
          &lt;<b>describe_auth&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_describe_auth">describe_auth</a> command.
          </div>
</li>
<li>
          &lt;<b>describe_feed&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_describe_feed">describe_feed</a> command.
          </div>
</li>
<li>
          &lt;<b>describe_scap&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_describe_scap">describe_scap</a> command.
          </div>
</li>
<li>
          &lt;<b>describe_cert&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_describe_cert">describe_cert</a> command.
          </div>
</li>
<li>
          &lt;<b>get_settings&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_get_settings">get_settings</a> command.
          </div>
</li>
<li>
          &lt;<b>get_users&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_get_users">get_users</a> command.
          </div>
</li>
<li>
          &lt;<b>get_version&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_get_version">get_version</a> command.
          </div>
</li>
<li>
          &lt;<b>help&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_help">help</a> command.
          </div>
</li>
<li>
          &lt;<b>modify_auth&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_modify_auth">modify_auth</a> command.
          </div>
</li>
<li>
          &lt;<b>modify_user&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_modify_user">modify_user</a> command.
          </div>
</li>
<li>
          &lt;<b>sync_feed&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_sync_feed">sync_feed</a> command.
          </div>
</li>
<li>
          &lt;<b>sync_scap&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_sync_scap">sync_scap</a> command.
          </div>
</li>
<li>
          &lt;<b>sync_cert&gt;</b><div style="margin-left: 15px; display: inline;">
<a href="#command_sync_cert">sync_cert</a> command.
          </div>
</li>
</ul>
</li></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
<li>
<i>One of</i><b>*</b><ul style="list-style: none">
<li>
          &lt;<b>authenticate_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_authenticate">authenticate</a> command.
          </div>
</li>
<li>
          &lt;<b>commands_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_commands">commands</a> command.
          </div>
</li>
<li>
          &lt;<b>create_user_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_create_user">create_user</a> command.
          </div>
</li>
<li>
          &lt;<b>delete_user_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_delete_user">delete_user</a> command.
          </div>
</li>
<li>
          &lt;<b>describe_auth_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_describe_auth">describe_auth</a> command.
          </div>
</li>
<li>
          &lt;<b>describe_feed_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_describe_feed">describe_feed</a> command.
          </div>
</li>
<li>
          &lt;<b>describe_scap_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_describe_scap">describe_scap</a> command.
          </div>
</li>
<li>
          &lt;<b>describe_cert_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_describe_cert">describe_cert</a> command.
          </div>
</li>
<li>
          &lt;<b>get_settings_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_get_settings">get_settings</a> command.
          </div>
</li>
<li>
          &lt;<b>get_users_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_get_users">get_users</a> command.
          </div>
</li>
<li>
          &lt;<b>get_version_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_get_version">get_version</a> command.
          </div>
</li>
<li>
          &lt;<b>help_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_help">help</a> command.
          </div>
</li>
<li>
          &lt;<b>modify_auth_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_modify_auth">modify_auth</a> command.
          </div>
</li>
<li>
          &lt;<b>modify_user_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_modify_user">modify_user</a> command.
          </div>
</li>
<li>
          &lt;<b>sync_feed_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_sync_feed">sync_feed</a> command.
          </div>
</li>
<li>
          &lt;<b>sync_scap_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_sync_scap">sync_scap</a> command.
          </div>
</li>
<li>
          &lt;<b>sync_cert_response&gt;</b><div style="margin-left: 15px; display: inline;">
            Response to <a href="#command_sync_cert">sync_cert</a> command.
          </div>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<h4>7.2.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>commands
 = element commands
     {
       ( authenticate
           | commands
           | create_user
           | delete_user
           | describe_auth
           | describe_feed
           | describe_scap
           | describe_cert
           | get_settings
           | get_users
           | get_version
           | help
           | modify_auth
           | modify_user
           | sync_feed
           | sync_scap
           | sync_cert )*
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>commands_response
 = element commands_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
       &amp; ( authenticate_response
           | commands_response
           | create_user_response
           | delete_user_response
           | describe_auth_response
           | describe_feed_response
           | describe_scap_response
           | describe_cert_response
           | get_settings_response
           | get_users_response
           | get_version_response
           | help_response
           | modify_auth_response
           | modify_user_response
           | sync_feed_response
           | sync_scap_response
           | sync_cert_response )*
     }
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_create_user">7.3
        Command <tt>create_user</tt>
</h3></div>
<p>In short: Create a user.</p>
<p>
        The client uses the create_user command to create a new user.
      </p>
<h4>7.3.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none">
<li>
              &lt;<b>name</b>&gt;
              <div style="margin-left: 15px; display: inline;">The name of the user to be created.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>hosts</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">User access rules: a textual list of hosts.</div>
<ul style="list-style: none"><li>
          @<b>allow</b>
          (<a href="#type_boolean">boolean</a>)
          </li></ul>
</li>
<li>
              &lt;<b>password</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">The password for the user.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>role</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">The role of the user.</div>
<ul style="list-style: none"></ul>
</li>
</ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
<li>
          @<b>id</b>
          (<a href="#type_uuid">uuid</a>)
          </li>
</ul>
</li>
</ul>
<h4>7.3.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>create_user
 = element create_user
     {
       create_user_name
       &amp; create_user_hosts?
       &amp; create_user_password?
       &amp; create_user_role?
     }

create_user_name
 = element name
     {
       text
     }

create_user_hosts
 = element hosts
     {
       text
       &amp; attribute allow { boolean }?
     }

create_user_password
 = element password
     {
       text
     }

create_user_role
 = element role
     {
       xsd:token { pattern = "Administrator|User|Observer" }
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>create_user_response
 = element create_user_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
       &amp; attribute id { uuid }
     }
</pre></div>
</div>
<h4>7.3.3 Example: Create a user</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;create_user&gt;
   &lt;name&gt;foobar&lt;/name&gt;
   &lt;password&gt;f00bar&lt;/password&gt;
   &lt;role&gt;User&lt;/role&gt;
 &lt;/create_user&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;create_user_response status="201"
                       status_text="OK, resource created"/&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_delete_user">7.4
        Command <tt>delete_user</tt>
</h3></div>
<p>In short: Delete a user.</p>
<p>
        The client uses the delete_user command to delete an existing user.
      </p>
<p>
        Since this is a destructive command, the client is advised to ask
        for confirmation from the user before sending this command to the
        Administrator.
      </p>
<h4>7.4.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><li>
              &lt;<b>name</b>&gt;
              <div style="margin-left: 15px; display: inline;">The name of the user to be deleted.</div>
<ul style="list-style: none"></ul>
</li></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
</ul>
</li>
</ul>
<h4>7.4.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>delete_user
 = element delete_user
     {
       delete_user_name
     }

delete_user_name
 = element name
     {
       text
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>delete_user_response
 = element delete_user_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
     }
</pre></div>
</div>
<h4>7.4.3 Example: Delete a user</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;delete_user name="foobar"/&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;delete_user_response status="200"
                       status_text="OK"/&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_describe_auth">7.5
        Command <tt>describe_auth</tt>
</h3></div>
<p>In short: Describe a auth.</p>
<p>
        The client uses the "describe_auth" command to get details about the
        used authentication methods.
      </p>
<p>
        The administrator will reply with a list of all used authentication
        methods if such a list is available.
      </p>
<h4>7.5.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><i>Empty single element.</i></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
<li>
              &lt;<b>group</b>&gt;
              <div style="margin-left: 15px; display: inline;">Config group.</div>
<ul style="list-style: none">
<li>
          @<b>name</b>
          (text)
          </li>
<li>
              &lt;<b>auth_conf_setting</b>&gt;
              <ul style="list-style: none">
<li>
          @<b>key</b>
          (text)
          </li>
<li>
          @<b>value</b>
          (text)
          </li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<h4>7.5.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>describe_auth
 = element describe_auth
     {
       ""
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>describe_auth_response
 = element describe_auth_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
       &amp; describe_auth_response_group
     }

describe_auth_response_group
 = element group
     {
       attribute name { text }
       &amp; describe_auth_response_group_auth_conf_setting
     }

describe_auth_response_group_auth_conf_setting
 = element auth_conf_setting
     {
       attribute key { text }
       &amp; attribute value { text }
     }
</pre></div>
</div>
<h4>7.5.3 Example: Describe the authentication methods</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;describe_auth/&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;describe_auth_response status="200"
                         status_text="OK"&gt;
   &lt;group name="Foo"&gt;
     &lt;auth_conf_setting key="Bar"
                        value="Baz"/&gt;
   &lt;/group&gt;
 &lt;/describe_auth_response&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_describe_feed">7.6
        Command <tt>describe_feed</tt>
</h3></div>
<p>In short: Describe the NVT feed.</p>
<p>
        The client uses the "describe_feed" command to get details about
        the NVT feed used by the administrator.
      </p>
<p>
        The Administrator will reply with a feed element containing
        information about the NVT feed.
      </p>
<h4>7.6.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><i>Empty single element.</i></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
<li>
              &lt;<b>feed</b>&gt;
              <ul style="list-style: none">
<li>
              &lt;<b>name</b>&gt;
              <div style="margin-left: 15px; display: inline;">The name of the feed.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>version</b>&gt;
              <div style="margin-left: 15px; display: inline;">The version of the feed.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>description</b>&gt;
              <div style="margin-left: 15px; display: inline;">A description of the feed.</div>
<ul style="list-style: none"></ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<h4>7.6.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>describe_feed
 = element describe_feed
     {
       ""
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>describe_feed_response
 = element describe_feed_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
       &amp; describe_feed_response_feed
     }

describe_feed_response_feed
 = element feed
     {
       describe_feed_response_feed_name
       &amp; describe_feed_response_feed_version
       &amp; describe_feed_response_feed_description
     }

describe_feed_response_feed_name
 = element name
     {
       text
     }

describe_feed_response_feed_version
 = element version
     {
       text
     }

describe_feed_response_feed_description
 = element description
     {
       text
     }
</pre></div>
</div>
<h4>7.6.3 Example: Describe the feed</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;describe_feed/&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;describe_feed_response status="200"
                         status_text="OK"&gt;
   &lt;feed&gt;
     &lt;name&gt;OpenVAS NVT Feed&lt;/name&gt;
     &lt;version&gt;201011221324&lt;/version&gt;
     &lt;description&gt;
       The 'OpenVAS NVT Feed' is provided by 'The OpenVAS Project'.
       ...
     &lt;/description&gt;
   &lt;/feed&gt;
 &lt;/describe_feed_response&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_describe_scap">7.7
        Command <tt>describe_scap</tt>
</h3></div>
<p>In short: Describe the SCAP feed.</p>
<p>
        The client uses the "describe_scap" command to get details about
        the SCAP feed used by the administrator.
      </p>
<p>
        The Administrator will reply with a scap element containing
        information about the SCAP feed.
      </p>
<h4>7.7.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><i>Empty single element.</i></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
<li>
              &lt;<b>scap</b>&gt;
              <ul style="list-style: none">
<li>
              &lt;<b>name</b>&gt;
              <div style="margin-left: 15px; display: inline;">The name of the scap feed.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>version</b>&gt;
              <div style="margin-left: 15px; display: inline;">The version of the scap feed.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>description</b>&gt;
              <div style="margin-left: 15px; display: inline;">A description of the scap feed.</div>
<ul style="list-style: none"></ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<h4>7.7.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>describe_scap
 = element describe_scap
     {
       ""
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>describe_scap_response
 = element describe_scap_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
       &amp; describe_scap_response_scap
     }

describe_scap_response_scap
 = element scap
     {
       describe_scap_response_scap_name
       &amp; describe_scap_response_scap_version
       &amp; describe_scap_response_scap_description
     }

describe_scap_response_scap_name
 = element name
     {
       text
     }

describe_scap_response_scap_version
 = element version
     {
       text
     }

describe_scap_response_scap_description
 = element description
     {
       text
     }
</pre></div>
</div>
<h4>7.7.3 Example: Describe the scap feed</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;describe_scap/&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;describe_scap_response status="200"
                         status_text="OK"&gt;
   &lt;scap&gt;
     &lt;name&gt;OpenVAS NVT SCAP&lt;/name&gt;
     &lt;version&gt;201011221324&lt;/version&gt;
     &lt;description&gt;
       The 'OpenVAS SCAP Feed' is provided by 'The OpenVAS Project'.
       ...
     &lt;/description&gt;
   &lt;/scap&gt;
 &lt;/describe_scap_response&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_describe_cert">7.8
        Command <tt>describe_cert</tt>
</h3></div>
<p>In short: Describe the CERT feed.</p>
<p>
        The client uses the "describe_cert" command to get details about
        the CERT feed used by the administrator.
      </p>
<p>
        The Administrator will reply with a cert element containing
        information about the CERT feed.
      </p>
<h4>7.8.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><i>Empty single element.</i></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
<li>
              &lt;<b>cert</b>&gt;
              <ul style="list-style: none">
<li>
              &lt;<b>name</b>&gt;
              <div style="margin-left: 15px; display: inline;">The name of the CERT feed.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>version</b>&gt;
              <div style="margin-left: 15px; display: inline;">The version of the CERT feed.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>description</b>&gt;
              <div style="margin-left: 15px; display: inline;">A description of the CERT feed.</div>
<ul style="list-style: none"></ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<h4>7.8.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>describe_cert
 = element describe_cert
     {
       ""
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>describe_cert_response
 = element describe_cert_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
       &amp; describe_cert_response_cert
     }

describe_cert_response_cert
 = element cert
     {
       describe_cert_response_cert_name
       &amp; describe_cert_response_cert_version
       &amp; describe_cert_response_cert_description
     }

describe_cert_response_cert_name
 = element name
     {
       text
     }

describe_cert_response_cert_version
 = element version
     {
       text
     }

describe_cert_response_cert_description
 = element description
     {
       text
     }
</pre></div>
</div>
<h4>7.8.3 Example: Describe the CERT feed</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;describe_cert/&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;describe_cert_response status="200"
                         status_text="OK"&gt;
   &lt;cert&gt;
     &lt;name&gt;OpenVAS CERT Feed&lt;/name&gt;
     &lt;version&gt;201301040805&lt;/version&gt;
     &lt;description&gt;
       The 'OpenVAS CERT Feed' is provided by 'The OpenVAS Project'.
       ...
     &lt;/description&gt;
   &lt;/cert&gt;
 &lt;/describe_cert_response&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_get_settings">7.9
        Command <tt>get_settings</tt>
</h3></div>
<p>In short: Get all settings.</p>
<p>
        The client uses the "get_settings" command to retrieve a list of all
        settings set for the Scanner controlled by this Administrator.
      </p>
<p>
        The Administrator will reply with a list of all known settings and
        their values.
      </p>
<h4>7.9.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><i>Empty single element.</i></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
<li>
              &lt;<b>scanner_settings</b>&gt;
              <ul style="list-style: none"><li>
              &lt;<b>setting</b>&gt;
              *<div style="margin-left: 15px; display: inline;">The name of the setting.</div>
<ul style="list-style: none"><li>
          @<b>name</b>
          (text)
          </li></ul>
</li></ul>
</li>
</ul>
</li>
</ul>
<h4>7.9.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>get_settings
 = element get_settings
     {
       ""
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>get_settings_response
 = element get_settings_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
       &amp; get_settings_response_scanner_settings
     }

get_settings_response_scanner_settings
 = element scanner_settings
     {
       get_settings_response_scanner_settings_setting*
     }

get_settings_response_scanner_settings_setting
 = element setting
     {
       text
       &amp; attribute name { text }
     }
</pre></div>
</div>
<h4>7.9.3 Example: Get the settings</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;get_settings/&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;get_settings_response status="200"
                        status_text="OK"&gt;
   &lt;scanner_settings sourcefile="/etc/openvas/openvassd.conf"
                     editable="0"&gt;
     &lt;setting name="safe_checks"&gt;yes&lt;/setting&gt;
     ...
   &lt;/scanner_settings&gt;
 &lt;/get_settings_response&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_get_users">7.10
        Command <tt>get_users</tt>
</h3></div>
<p>In short: Get all users.</p>
<p>
        The client uses the "get_users" command to retrieve the list of user
        accounts on the Scanner.
      </p>
<h4>7.10.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><i>Empty single element.</i></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
<li>
              &lt;<b>user</b>&gt;
              *<ul style="list-style: none">
<li>
              &lt;<b>name</b>&gt;
              <div style="margin-left: 15px; display: inline;">The name of the user.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>role</b>&gt;
              <div style="margin-left: 15px; display: inline;">The role of the user.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>hosts</b>&gt;
              <div style="margin-left: 15px; display: inline;">Host access rule for the user.</div>
<ul style="list-style: none"><li>
          @<b>allow</b>
          ("0", "1", "2" or "3")
          0 forbidden, 1 allowed, 2 all allowed, 3 custom.
          </li></ul>
</li>
<li>
              &lt;<b>sources</b>&gt;
              <div style="margin-left: 15px; display: inline;">(<a href="#element_sources">sources</a>)</div>
<div style="margin-left: 15px; display: inline;">Sources allowed for authentication for this user.</div>
<ul style="list-style: none"></ul>
</li>
</ul>
</li>
</ul>
</li>
</ul>
<h4>7.10.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>get_users
 = element get_users
     {
       ""
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>get_users_response
 = element get_users_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
       &amp; get_users_response_user*
     }

get_users_response_user
 = element user
     {
       get_users_response_user_name
       &amp; get_users_response_user_role
       &amp; get_users_response_user_hosts
       &amp; get_users_response_user_sources
     }

get_users_response_user_name
 = element name
     {
       text
     }

get_users_response_user_role
 = element role
     {
       xsd:token { pattern = "Admin|User|Observer" }
     }

get_users_response_user_hosts
 = element hosts
     {
       text
       &amp; attribute allow { xsd:token { pattern = "0|1|2|3" } }
     }

get_users_response_user_sources
 = element sources    # type sources
     {
       sources_source*
     }
</pre></div>
</div>
<h4>7.10.3 Example: Get the users</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;get_users/&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;get_users_response status="200"
                     status_text="OK"&gt;
   &lt;user&gt;
     &lt;name&gt;foobar&lt;/name&gt;
     &lt;role&gt;User&lt;/role&gt;
     &lt;hosts allow="2"/&gt;
     &lt;sources&gt;
       &lt;source&gt;file&lt;/source&gt;
     &lt;/sources&gt;
   &lt;/user&gt;
 &lt;/get_users_response&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_get_version">7.11
        Command <tt>get_version</tt>
</h3></div>
<p>In short: Get the OpenVAS Administrator Protocol version.</p>
<h4>7.11.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><i>Empty single element.</i></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
<li>
              &lt;<b>version</b>&gt;
              <ul style="list-style: none"></ul>
</li>
</ul>
</li>
</ul>
<h4>7.11.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>get_version
 = element get_version
     {
       ""
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>get_version_response
 = element get_version_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
       &amp; get_version_response_version
     }

get_version_response_version
 = element version
     {
       text
     }
</pre></div>
</div>
<h4>7.11.3 Example: Get the version</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;get_version/&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;get_version_response status="200"
                       status_text="OK"&gt;
   &lt;version&gt;1.0&lt;/version&gt;
 &lt;/get_version_response&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_help">7.12
        Command <tt>help</tt>
</h3></div>
<p>In short: Get the help text.</p>
<h4>7.12.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><li>
          @<b>format</b>
          ("html", "HTML", "rnc", "RNC", "text", "TEXT", "xml" or "XML")
          Required help format.
          </li></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
<li>
              &lt;<b>schema</b>&gt;
              ?<ul style="list-style: none"><li>
              &lt;<b>protocol</b>&gt;
              <ul style="list-style: none">
<li>
              &lt;<b>name</b>&gt;
              <div style="margin-left: 15px; display: inline;">The full name of the protocol.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>abbreviation</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">The abbreviated name of the protocol.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>summary</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">A summary of the protocol.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>version</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">The version number of the protocol.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>type</b>&gt;
              *<div style="margin-left: 15px; display: inline;">A data type.</div>
<ul style="list-style: none">
<li>
              &lt;<b>name</b>&gt;
              <div style="margin-left: 15px; display: inline;">The name of the data type.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>summary</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">A summary of the data type.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>description</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">A description of the data type.</div>
<ul style="list-style: none"><li>
              &lt;<b>p</b>&gt;
              *<div style="margin-left: 15px; display: inline;">A paragraph.</div>
<ul style="list-style: none"></ul>
</li></ul>
</li>
<li>
              &lt;<b>pattern</b>&gt;
              <div style="margin-left: 15px; display: inline;">The RNC pattern for the data type.</div>
<ul style="list-style: none"></ul>
</li>
</ul>
</li>
<li>
              &lt;<b>command</b>&gt;
              *<div style="margin-left: 15px; display: inline;">(<a href="#element_command_definition">command_definition</a>)</div>
<div style="margin-left: 15px; display: inline;">A command.</div>
<ul style="list-style: none"></ul>
</li>
</ul>
</li></ul>
</li>
</ul>
</li>
</ul>
<h4>7.12.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>help
 = element help
     {
       attribute format { xsd:token { pattern = "html|HTML|rnc|RNC|text|TEXT|xml|XML" } }?
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>help_response
 = element help_response
     {
       text
       &amp; attribute status { status }
       &amp; attribute status_text { text }
       &amp; help_response_schema?
     }

help_response_schema
 = element schema
     {
       help_response_schema_protocol
     }

help_response_schema_protocol
 = element protocol
     {
       help_response_schema_protocol_name
       &amp; help_response_schema_protocol_abbreviation?
       &amp; help_response_schema_protocol_summary?
       &amp; help_response_schema_protocol_version?
       &amp; help_response_schema_protocol_type*
       &amp; help_response_schema_protocol_command*
     }

help_response_schema_protocol_name
 = element name
     {
       text
     }

help_response_schema_protocol_abbreviation
 = element abbreviation
     {
       text
     }

help_response_schema_protocol_summary
 = element summary
     {
       text
     }

help_response_schema_protocol_version
 = element version
     {
       text
     }

help_response_schema_protocol_type
 = element type
     {
       help_response_schema_protocol_type_name
       &amp; help_response_schema_protocol_type_summary?
       &amp; help_response_schema_protocol_type_description?
       &amp; help_response_schema_protocol_type_pattern
     }

help_response_schema_protocol_type_name
 = element name
     {
       type_name
     }

help_response_schema_protocol_type_summary
 = element summary
     {
       text
     }

help_response_schema_protocol_type_description
 = element description
     {
       text
       &amp; help_response_schema_protocol_type_description_p*
     }

help_response_schema_protocol_type_description_p
 = element p
     {
       text
     }

help_response_schema_protocol_type_pattern
 = element pattern
     {
       text
     }

help_response_schema_protocol_command
 = element command    # type command_definition
     {
       command_definition_name
       &amp; command_definition_summary?
       &amp; command_definition_description?
       &amp; ( ( command_definition_pattern
           &amp; command_definition_response )
           | ( command_definition_type
           &amp; command_definition_ele* ) )
       &amp; command_definition_example*
     }
</pre></div>
</div>
<h4>7.12.3 Example: Get the help text</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;help/&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;help_response status="200"
                status_text="OK"&gt;
            AUTHENTICATE     Authenticate with the administrator.
            COMMANDS         Run a list of commands.
            CREATE_USER      Create a new user.
            DELETE_USER      Delete an existing user.
            DESCRIBE_AUTH    Get details about the used authentication methods.
            DESCRIBE_FEED    Get details of the NVT feed this administrator uses.
            DESCRIBE_SCAP    Get details of the SCAP feed this administrator uses.
            DESCRIBE_CERT    Get details of the CERT feed this administrator uses.
            GET_SETTINGS     Get scanner settings.
            GET_USERS        Get all users.
            GET_VERSION      Get the OpenVAS Administrator Protocol version.
            HELP             Get this help text.
            MODIFY_AUTH      Modify the authentication methods.
            MODIFY_USER      Modify a user.
            SYNC_FEED        Synchronize with an NVT feed.
            SYNC_SCAP        Synchronize with a SCAP feed.
            SYNC_CERT        Synchronize with a CERT feed.
 &lt;/help_response&gt;
</pre></div>
</div>
<h4>7.12.3 Example: Get the OAP schema</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;help format="XML"/&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;help_response status="200"
                status_text="OK"&gt;
   &lt;schema format="XML"
           extension="xml"
           content_type="text/xml"&gt;
     &lt;protocol&gt;
       &lt;name&gt;OpenVAS Administrator Protocol&lt;/name&gt;
       &lt;abbreviation&gt;OAP&lt;/abbreviation&gt;
       &lt;summary&gt;
         The "administrator" protocol of the Open Vulnerability Assessment System
       &lt;/summary&gt;
       &lt;version&gt;1.0&lt;/version&gt;
       &lt;type&gt;
         &lt;name&gt;base64&lt;/name&gt;
         &lt;summary&gt;Base64 encoded data&lt;/summary&gt;
         &lt;pattern&gt;xsd:base64Binary&lt;/pattern&gt;
       &lt;/type&gt;
       ...
       &lt;command&gt;
         &lt;name&gt;authenticate&lt;/name&gt;
         &lt;summary&gt;Authenticate with the Administrator&lt;/summary&gt;
         &lt;description&gt;
           &lt;p&gt;
                    The client uses the authenticate command to authenticate with the
                    Administrator.
           &lt;/p&gt;
           &lt;p&gt;
                    The client normally executes this command at the beginning of each
                    connection.  The only commands permitted before authentication are
                    get_version and commands.
           &lt;/p&gt;
         &lt;/description&gt;
         &lt;pattern&gt;
           &lt;e&gt;credentials&lt;/e&gt;
         &lt;/pattern&gt;
         &lt;ele&gt;
           &lt;name&gt;credentials&lt;/name&gt;
           &lt;pattern&gt;
             &lt;e&gt;username&lt;/e&gt;
             &lt;e&gt;password&lt;/e&gt;
           &lt;/pattern&gt;
           &lt;ele&gt;
             &lt;name&gt;username&lt;/name&gt;
             &lt;summary&gt;The login name of the user&lt;/summary&gt;
             &lt;pattern&gt;text&lt;/pattern&gt;
           &lt;/ele&gt;
           &lt;ele&gt;
             &lt;name&gt;password&lt;/name&gt;
             &lt;summary&gt;The user's password&lt;/summary&gt;
             &lt;pattern&gt;text&lt;/pattern&gt;
           &lt;/ele&gt;
         &lt;/ele&gt;
         &lt;response&gt;
           &lt;pattern&gt;
             &lt;attrib&gt;
               &lt;name&gt;status&lt;/name&gt;
               &lt;type&gt;status&lt;/type&gt;
               &lt;required&gt;1&lt;/required&gt;
             &lt;/attrib&gt;
             &lt;attrib&gt;
               &lt;name&gt;status_text&lt;/name&gt;
               &lt;type&gt;text&lt;/type&gt;
               &lt;required&gt;1&lt;/required&gt;
             &lt;/attrib&gt;
           &lt;/pattern&gt;
         &lt;/response&gt;
         &lt;example&gt;
           &lt;summary&gt;Authenticate with a good password&lt;/summary&gt;
           &lt;request&gt;
             &lt;authenticate&gt;
               &lt;credentials&gt;
                 &lt;username&gt;sally&lt;/username&gt;
                 &lt;password&gt;secret&lt;/password&gt;
               &lt;/credentials&gt;
             &lt;/authenticate&gt;
           &lt;/request&gt;
           &lt;response&gt;
             &lt;authenticate_response status="200"
                                    status_text="OK"/&gt;
           &lt;/response&gt;
         &lt;/example&gt;
         ...
       &lt;/command&gt;
       ...
     &lt;/protocol&gt;
   &lt;/schema&gt;
 &lt;/help_response&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_modify_auth">7.13
        Command <tt>modify_auth</tt>
</h3></div>
<p>In short: Modify the authentication methods.</p>
<p>
        The client uses the "modify_auth" command to modify the authentication
        methods.
      </p>
<h4>7.13.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><li>
              &lt;<b>group</b>&gt;
              <ul style="list-style: none"><li>
              &lt;<b>auth_conf_setting</b>&gt;
              *<div style="margin-left: 15px; display: inline;">A setting to modify.</div>
<ul style="list-style: none">
<li>
          @<b>key</b>
          (text)
          </li>
<li>
          @<b>value</b>
          (text)
          </li>
</ul>
</li></ul>
</li></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
</ul>
</li>
</ul>
<h4>7.13.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>modify_auth
 = element modify_auth
     {
       modify_auth_group
     }

modify_auth_group
 = element group
     {
       modify_auth_group_auth_conf_setting*
     }

modify_auth_group_auth_conf_setting
 = element auth_conf_setting
     {
       attribute key { text }
       &amp; attribute value { text }
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>modify_auth_response
 = element modify_auth_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
     }
</pre></div>
</div>
<h4>7.13.3 Example: Modify a single setting for an authentication method</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;modify_auth&gt;
   &lt;group name="Foo"&gt;
     &lt;auth_conf_setting key="Bar"
                        value="Baz"/&gt;
   &lt;/group&gt;
 &lt;/modify_auth&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;modify_auth_response status="200"
                       status_text="OK"/&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_modify_user">7.14
        Command <tt>modify_user</tt>
</h3></div>
<p>In short: Modify a user.</p>
<p>
        The client uses the "modify_user" command to modify an user account
        on the OpenVAS server.
      </p>
<h4>7.14.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none">
<li>
              &lt;<b>name</b>&gt;
              <div style="margin-left: 15px; display: inline;">The name of the user to be modified.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>password</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">The password for the user.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>role</b>&gt;
              <div style="margin-left: 15px; display: inline;">The role of the user.</div>
<ul style="list-style: none"></ul>
</li>
<li>
              &lt;<b>hosts</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">User access rules: a textual list of hosts.</div>
<ul style="list-style: none"><li>
          @<b>allow</b>
          (<a href="#type_boolean">boolean</a>)
          </li></ul>
</li>
<li>
              &lt;<b>sources</b>&gt;
              ?<div style="margin-left: 15px; display: inline;">(<a href="#element_sources">sources</a>)</div>
<div style="margin-left: 15px; display: inline;">List of authentication sources for this user (if omitted, no changes).</div>
<ul style="list-style: none"></ul>
</li>
</ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
</ul>
</li>
</ul>
<h4>7.14.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>modify_user
 = element modify_user
     {
       modify_user_name
       &amp; modify_user_password?
       &amp; modify_user_role
       &amp; modify_user_hosts?
       &amp; modify_user_sources?
     }

modify_user_name
 = element name
     {
       text
     }

modify_user_hosts
 = element hosts
     {
       text
       &amp; attribute allow { boolean }?
     }

modify_user_password
 = element password
     {
       text
     }

modify_user_role
 = element role
     {
       xsd:token { pattern = "Administrator|User|Observer" }
     }

modify_user_sources
 = element sources    # type sources
     {
       sources_source*
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>modify_user_response
 = element modify_user_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
     }
</pre></div>
</div>
<h4>7.14.3 Example: Modify a user</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;modify_user&gt;
   &lt;name&gt;Foobar&lt;/name&gt;
   &lt;password modify="0"/&gt;
   &lt;role&gt;Admin&lt;/role&gt;
   &lt;hosts allow="0"/&gt;
 &lt;/modify_user&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;modify_user_response status="200"
                       status_text="OK"/&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_sync_feed">7.15
        Command <tt>sync_feed</tt>
</h3></div>
<p>In short: Synchronize with an NVT feed.</p>
<p>
        The client uses the "sync_feed" command to request a
        synchronization with the NVT feed service the Administrator uses.
      </p>
<h4>7.15.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><i>Empty single element.</i></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
</ul>
</li>
</ul>
<h4>7.15.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>sync_feed
 = element sync_feed
     {
       ""
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>sync_feed_response
 = element sync_feed_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
     }
</pre></div>
</div>
<h4>7.15.3 Example: Sync the feed</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;sync_feed/&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;sync_feed_response status="202"
                     status_text="OK, request submitted"/&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_sync_scap">7.16
        Command <tt>sync_scap</tt>
</h3></div>
<p>In short: Synchronize with a SCAP feed.</p>
<p>
        The client uses the "sync_scap" command to request a
        synchronization with the SCAP feed service the Administrator uses.
      </p>
<h4>7.16.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><i>Empty single element.</i></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
</ul>
</li>
</ul>
<h4>7.16.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>sync_scap
 = element sync_scap
     {
       ""
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>sync_scap_response
 = element sync_scap_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
     }
</pre></div>
</div>
<h4>7.16.3 Example: Sync the feed</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;sync_scap/&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;sync_scap_response status="202"
                     status_text="OK, request submitted"/&gt;
</pre></div>
</div>
</div>
<div>
<div><h3 id="command_sync_cert">7.17
        Command <tt>sync_cert</tt>
</h3></div>
<p>In short: Synchronize with a CERT feed.</p>
<p>
        The client uses the "sync_cert" command to request a
        synchronization with the CERT feed service the Administrator uses.
      </p>
<h4>7.17.1 Structure</h4>
<ul style="list-style: none">
<li>
<i>Command</i><ul style="list-style: none"><i>Empty single element.</i></ul>
</li>
<li style="margin-top: 15px;">
<i>Response</i><ul style="list-style: none">
<li>
          @<b>status</b>
          (<a href="#type_status">status</a>)
          </li>
<li>
          @<b>status_text</b>
          (text)
          </li>
</ul>
</li>
</ul>
<h4>7.17.2 RNC</h4>
<div style="border: 1px solid; padding:10px; width: 85%; align: center; margin-left: auto; margin-right: auto; background: #d5d5d5;">
<i>Command</i><div style="margin-left: 5%"><pre>sync_cert
 = element sync_cert
     {
       ""
     }
</pre></div>
<i>Response</i><div style="margin-left: 5%"><pre>sync_cert_response
 = element sync_cert_response
     {
       attribute status { status }
       &amp; attribute status_text { text }
     }
</pre></div>
</div>
<h4>7.17.3 Example: Sync the feed</h4>
<div style="margin-left: 5%; margin-right: 5%;">
<i>Client</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;sync_cert/&gt;
</pre></div>
<i>Administrator</i><div style="margin-left: 2%; margin-right: 2%;"><pre> &lt;sync_cert_response status="202"
                     status_text="OK, request submitted"/&gt;
</pre></div>
</div>
</div>
<div style="text-align: center; padding: 5px;">
                  This file was automatically generated.
                </div>
</td></tr></table></div></body>
</html>
